﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WPF_xamOrgChart
{
    public class Department
    {
        public Department(string name)
        {
            this.Name = name;
            this.EmployeePositions = new ObservableCollection<EmployeePosition>();
        }

        public string Name { get; set; }
        public ObservableCollection<EmployeePosition> EmployeePositions { get; set; }
    }

    public class EmployeePosition
    {
        public EmployeePosition(string jobTitle)
        {
            this.JobTitle = jobTitle;
            this.Employees = new ObservableCollection<Employee>();
        }

        public string JobTitle { get; set; }
        public ObservableCollection<Employee> Employees { get; set; }
    }

    public class Employee
    {
        public Employee(string firstName, string lastName, string jobTitle, string imageURL, ObservableCollection<Employee>reports)
        {
            this.FirstName = firstName;
            this.LastName = lastName;
            this.JobTitle = jobTitle;
            this.ImageURL = imageURL;
            this.Reports = reports;
        }

        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string JobTitle { get; set; }
        public string ImageURL { get; set; }
        public ObservableCollection<Employee> Reports { get; set; }
    }

    public class DepartmentViewModel
    {
        public ObservableCollection<Department> Departments { get; set; }
       
        public DepartmentViewModel()
        {

            string[] fmnames = {"Jim", "John", "Mike", "Tom", "Andy", "Alan", "Dave", };
            string[] ffnames = {  "Sue", "Mary",  "Alice", "Jeri", "Val", "Fern" };
            string[] lnames = { "Brown", "Smith", "Jones", "Black", "White", "Bush", "DiAngelo", "Michaelson", "Jamison", "Caligh" };
            string[] imgnums = { "01", "02", "03", "04", "05", "06", "07", "08", "09", "10" };
            Random r = new Random();

            Employee employee9 = new Employee("James", "Jones", "Senior Tool Designer", "/Images/People/GUY06.jpg", new ObservableCollection<Employee>());
            Employee employee10 = new Employee("Kim", "Brown", "Senior Tool Designer", "/Images/People/GIRL04.jpg", new ObservableCollection<Employee>());
            Employee employee11 = new Employee("Sarah", "Smith", "Tool Designer", "/Images/People/GIRL05.jpg", new ObservableCollection<Employee>());
            Employee employee12 = new Employee("Sean", "Black", "Tool Designer", "/Images/People/GUY07.jpg", new ObservableCollection<Employee>());

            ObservableCollection<Employee> reports3 = new ObservableCollection<Employee>();
            reports3.Add(employee9);
            reports3.Add(employee10);
            reports3.Add(employee11);
            reports3.Add(employee12);

            Employee e =  new Employee(fmnames[r.Next(0, 7)], lnames[r.Next(0, 9)], "Senior Tool Designer", "/Images/People/GUY01.jpg", new ObservableCollection<Employee>());            
            for (int i = 0; i < 9; i++)
            {               
                string imgnum = imgnums[r.Next(0,9)]; 
                e.Reports.Add(new Employee(fmnames[r.Next(0, 7)], lnames[r.Next(0, 9)], "Senior Tool Designer", "/Images/People/GUY" + imgnum + ".jpg", new ObservableCollection<Employee>()));                                        
                e.Reports.Last<Employee>().Reports.Add( new Employee(ffnames[r.Next(0, 5)], lnames[r.Next(0, 9)], "Senior Tool Designer", "/Images/People/GIRL" + imgnum + ".jpg", new ObservableCollection<Employee>()) );               
            }
            reports3.Add(e);

            Employee employee13 = new Employee("Suzanne", "Johnson", "Senior Tool Designer", "/Images/People/GIRL06.jpg", new ObservableCollection<Employee>());
            Employee employee14 = new Employee("Bill", "Taylor", "Senior Tool Designer", "/Images/People/GUY08.jpg", new ObservableCollection<Employee>());
            Employee employee15 = new Employee("Andy", "Clark", "Tool Designer", "/Images/People/GUY09.jpg", new ObservableCollection<Employee>());
            Employee employee16 = new Employee("Mary", "Peterson", "Tool Designer", "/Images/People/GIRL07.jpg", new ObservableCollection<Employee>());

            ObservableCollection<Employee> reports4 = new ObservableCollection<Employee>();
            reports4.Add(employee13);
            reports4.Add(employee14);
            reports4.Add(employee15);
            reports4.Add(employee16);

            e = new Employee(fmnames[r.Next(0, 7)], lnames[r.Next(0, 9)], "Senior Tool Designer", "/Images/People/GUY01.jpg", new ObservableCollection<Employee>());
            for (int i = 9; i < 17; i++)
            {
                string imgnum = imgnums[r.Next(0, 9)]; 

                e.Reports.Add(new Employee(fmnames[r.Next(0, 7)], lnames[r.Next(0, 9)], "Senior Tool Designer", "/Images/People/GUY" + imgnum + ".jpg", new ObservableCollection<Employee>()));
                e.Reports.Last<Employee>().Reports.Add(new Employee(ffnames[r.Next(0, 5)], lnames[r.Next(0, 9)], "Senior Tool Designer", "/Images/People/GIRL" + imgnum + ".jpg", new ObservableCollection<Employee>()));
            }
            reports4.Add(e);

            Employee employee5 = new Employee("John", "Walters", "Senior Tool Designer", "/Images/People/GUY04.jpg", reports3);
            Employee employee6 = new Employee("Jim", "Cracium", "Senior Tool Designer", "/Images/People/GUY05.jpg", reports4);
            Employee employee7 = new Employee("Nancy", "D'Hers", "Tool Designer", "/Images/People/GIRL02.jpg", new ObservableCollection<Employee>());
            Employee employee8 = new Employee("Sue", "Galvin", "Tool Designer", "/Images/People/GIRL03.jpg", new ObservableCollection<Employee>());
            ObservableCollection<Employee> reports1 = new ObservableCollection<Employee>();
            reports1.Add(employee5);
            reports1.Add(employee6);

            ObservableCollection<Employee> reports2 = new ObservableCollection<Employee>();
            reports2.Add(employee7);
            reports2.Add(employee8);

            e = new Employee(fmnames[r.Next(0, 7)], lnames[r.Next(0, 9)], "Senior Tool Designer", "/Images/People/GUY01.jpg", new ObservableCollection<Employee>());
            for (int i = 17; i < 25; i++)
            {
                string imgnum = imgnums[r.Next(0, 9)]; 

                e.Reports.Add(new Employee(fmnames[r.Next(0, 7)], lnames[r.Next(0, 9)], "Senior Tool Designer", "/Images/People/GUY" + imgnum + ".jpg", new ObservableCollection<Employee>()));
                e.Reports.Last<Employee>().Reports.Add(new Employee(ffnames[r.Next(0, 5)], lnames[r.Next(0, 9)], "Senior Tool Designer", "/Images/People/GIRL" + imgnum + ".jpg", new ObservableCollection<Employee>()));
            }
            reports1.Add(e);

            e = new Employee(fmnames[r.Next(0, 7)], lnames[r.Next(0, 9)], "Senior Tool Designer", "/Images/People/GUY01.jpg", new ObservableCollection<Employee>());
            for (int i = 25; i < 33; i++)
            {
                string imgnum = imgnums[r.Next(0, 9)]; 

                e.Reports.Add(new Employee(fmnames[r.Next(0, 7)], lnames[r.Next(0, 9)], "Senior Tool Designer", "/Images/People/GUY" + imgnum + ".jpg", new ObservableCollection<Employee>()));
                e.Reports.Last<Employee>().Reports.Add(new Employee(ffnames[r.Next(0, 5)], lnames[r.Next(0, 9)], "Senior Tool Designer", "/Images/People/GIRL" + imgnum + ".jpg", new ObservableCollection<Employee>()));
            }
            reports2.Add(e);

            Employee employee1 = new Employee("Rob", "Walters", "Senior Tool Designer", "/Images/People/GUY01.jpg", new ObservableCollection<Employee>());
            Employee employee2 = new Employee("Ovidiu", "Cracium", "Senior Tool Designer", "/Images/People/GUY02.jpg", new ObservableCollection<Employee>());
            Employee employee3 = new Employee("Thierry", "D'Hers", "Tool Designer", "/Images/People/GUY03.jpg", reports1);
            Employee employee4 = new Employee("Janice", "Galvin", "Tool Designer", "/Images/People/GIRL01.jpg", reports2);


            EmployeePosition position1 = new EmployeePosition("Senior Tool Designer");
            position1.Employees.Add(employee1);
            position1.Employees.Add(employee2);
           

            EmployeePosition position2 = new EmployeePosition("Tool Designer");
            position2.Employees.Add(employee3);
            position2.Employees.Add(employee4);
           

            Department department1 = new Department("Tool Design");
            department1.EmployeePositions.Add(position1);
            department1.EmployeePositions.Add(position2);

            this.Departments = new ObservableCollection<Department>();
            this.Departments.Add(department1);
        }
    }
}
